package cn.iocoder.yudao.module.pms.service.qhse.cert;

import cn.iocoder.yudao.framework.common.exception.ErrorCode;
import cn.iocoder.yudao.framework.common.exception.ServiceException;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.pms.controller.admin.qhse.cert.vo.QhseCertPersonPageReqVO;
import cn.iocoder.yudao.module.pms.controller.admin.qhse.cert.vo.QhseCertPersonSaveReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.qhse.cert.QhseCertPersonDO;
import cn.iocoder.yudao.module.pms.dal.mysql.qhse.cert.QhseCertPersonMapper;
import cn.iocoder.yudao.module.system.api.dept.DeptApi;
import cn.iocoder.yudao.module.system.api.dept.dto.DeptRespDTO;
import cn.iocoder.yudao.module.system.service.dept.DeptService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

import java.util.HashSet;
import java.util.Objects;
import java.util.Set;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;

/**
 * QHSE-证书人员 Service 实现类
 *
 * @author 超级管理员
 */
@Service
@Validated
public class QhseCertPersonServiceImpl implements QhseCertPersonService {

    @Resource
    private QhseCertPersonMapper qhseCertPersonMapper;
    @Autowired
    private DeptApi deptApi;
    @Autowired
    private DeptService deptService;

    @Override
    public Long createQhseCertPerson(QhseCertPersonSaveReqVO createReqVO) {
        // 插入
        QhseCertPersonDO qhseCertPerson = BeanUtils.toBean(createReqVO, QhseCertPersonDO.class);
        qhseCertPerson.setDeleted(false);
        if (Objects.isNull(createReqVO.getDeptId())) {
            throw new ServiceException(new ErrorCode(2,"不存在部门id"));
        }
        qhseCertPerson.setUsername(createReqVO.getMobile());
        DeptRespDTO dept = deptApi.getDept(createReqVO.getDeptId());
        qhseCertPerson.setDeptName(dept.getName());
        qhseCertPersonMapper.insert(qhseCertPerson);
        // 返回
        return qhseCertPerson.getId();
    }

    @Override
    public void updateQhseCertPerson(QhseCertPersonSaveReqVO updateReqVO) {
        // 校验存在
        validateQhseCertPersonExists(updateReqVO.getId());
        // 更新
        QhseCertPersonDO updateObj = BeanUtils.toBean(updateReqVO, QhseCertPersonDO.class);
        qhseCertPersonMapper.updateById(updateObj);
    }

    @Override
    public void deleteQhseCertPerson(Long id) {
        // 校验存在
        validateQhseCertPersonExists(id);
        // 删除
        qhseCertPersonMapper.deleteById(id);
    }

    private void validateQhseCertPersonExists(Long id) {
        if (qhseCertPersonMapper.selectById(id) == null) {
            throw exception(new ErrorCode(3,"不存在"));
        }
    }

    @Override
    public QhseCertPersonDO getQhseCertPerson(Long id) {
        return qhseCertPersonMapper.selectById(id);
    }

    @Override
    public PageResult<QhseCertPersonDO> getQhseCertPersonPage(QhseCertPersonPageReqVO pageReqVO) {
        Set<Long> ids = new HashSet<>();
        if (Objects.nonNull(pageReqVO.getDeptId())) {
            ids = deptService.getChildDeptIdListFromCache(pageReqVO.getDeptId());
            ids.add(pageReqVO.getDeptId());
        }
        return qhseCertPersonMapper.selectPage(pageReqVO, ids);
    }

}